// Peter Weigel

// integerfield  (class)

// Eine alternative Implementierung zu intfield.

package pefas.field;

public class integerfield implements iintfield {
  protected int[] items;

  public integerfield(int n) {                 // Feld erzeugen
    items  = new int[n];
  }

  public int length() {                        // Feldlnge ermitteln
    return items.length;
  }

  public void value(int i, int value) {        // Wert setzen
    items[i] = value;
  }

  public int value(int i) {                    // Wert ermitteln
    return items[i];
  }

  public boolean lt(int i, int j) {            // Vergleich zweier Elemente
    return (items[i] < items[j]);
  }

  public boolean gt(int i, int j) {            // Vergleich zweier Elemente
    return (items[i] > items[j]);
  }

  public boolean eq(int i, int j) {            // Vergleich zweier Elemente
    return (items[i] == items[j]);
  }

  public void exchange(int i, int j) {         // Austausch zweier Elemente
    int s    = items[i];
    items[i] = items[j];
    items[j] = s;
  }

  public void move(int i, int j) {             // Verschieben eines Elementes
    if (i < j) { moveup  (i, j); }
    else       { movedown(i, j); }
  }

  protected void moveup(int i, int j) {       // move fr i < j
    for (int k=i; k<j; k++) {
      exchange(k, k+1);
    }
  }

  protected void movedown(int i, int j) {     // move fr i >= j
    for (int k=i; k>j; k--) {
      exchange(k, k-1);
    }
  }

  public String toString() {                  // Listeninhalt ausgeben
    String s = "";
    for ( int i=0; i<length(); i++ ) {
      s += "," + items[i];
    }
    if (s.length() > 0) {s = s.substring(1); }
    return ("(" + s + ")");
  }
}

