// Peter Weigel

// intele    (class)
// intfield  (class)

/*
  +-----------------------------------------------------------------------------------------+
  | Implementierung von "ielement".                                                         |
  +------------+----------------------------------------------------------------------------+
  | name       | intele                                                                     |
  | extends    | element                                                                    |
  | implements | iintele                                                                    |
  | type       | class                                                                      |
  +------------+----------------------------------------------------------------------------+
  | public         intele(int value);        // Konstruktor, direkte Wertbergabe           |
  | public boolean lessthan(ielement ele);   //                                             |
  | public boolean equal(ielement ele);      //                                             |
  | public int     value();                  // Wert ermitteln                              |
  | public String  toString();               //                                             |
  +-----------------------------------------------------------------------------------------+

  +-----------------------------------------------------------------------------------------+
  | Implementierung von "iintfield".                                                        |
  +------------+----------------------------------------------------------------------------+
  | name       | intfield                                                                   |
  | extends    | field                                                                      |
  | implements | iintfield                                                                  |
  | type       | class                                                                      |
  +------------+----------------------------------------------------------------------------+
  | public             intfield(int n);           //                                        |
  | public    int      maxLength();               //                                        |
  | public    int      length();                  //                                        |
  | public    boolean  lt(int i, int j);          //                                        |
  | public    boolean  gt(int i, int j);          //                                        |
  | public    boolean  eq(int i, int j);          //                                        |
  | public    void     exchange(int i, int j);    //                                        |
  | protected void     item(int i, ielement ele); //                                        |
  | protected ielement item(int i);               //                                        |
  | public    void     value(int i, int value);   //                                        |
  | public    int      value(int i);              //                                        |
  | protected void     append(ielement ele);      //                                        |
  | public    void     append(int value);         // Neues Element am Ende hinzufgen       |
  | public    void     delete();                  // Letztes Element lschen                |
  | public    void     clear();                   // Alle Elemente lschen                  |
  | public    String   toString();                //                                        |
  +-----------------------------------------------------------------------------------------+

*/


package pefas.field;

class intele extends element {
  protected int value;                            // das eigentliche Element

  public intele(int value) {                      // Konstruktor
    this.value = value;                           // Integer-Wert bernehmen
  }

  public int value() {                            // Wert ermitteln
    return value;
  }

  public boolean lessthan(ielement ele) {          // Implementierung der abstrakten Methode
    return (this.value() < ((intele) ele).value());
  }

  public boolean equal(ielement ele) {             // Implementierung der abstrakten Methode
    return (this.value() == ((intele) ele).value());
  }

  public String toString() {                       // Implementierung der abstrakten Methode
    return Integer.toString(value());
  }
}

public final class intfield extends field implements iintfield {

  public intfield(int n) {                   // Der Konstruktor bleibt der selbe
    super(n);
  }

  public void value(int i, int value) {      // Wert setzen
    item(i, new intele(value));              // Element erzeugen und weiterreichen.
  }

  public int value(int i) {                  // Wert ermitteln
    return ((intele) item(i)).value();       // Element holen und explizit als intele casten.
  }

  public void append(int value) {            // Feld vergrern und neuen Wert am Ende einfgen
    append(new intele(value));               // Element erzeugen und weiterreichen.
  }
}

