// Peter Weigel

// Avlsort
// Variante 3

package pefas.sort;

import pefas.field.ifield;

public class avlsort3 extends sort{

  public void sort(ifield A, int l, int r) {
    node root = new node(l);
    for (int i=l+1;i<=r;i++) {
      root = insert(A, root, new node(i));
    }
    //checkbal(root);
    int[][] B = new int[2][r+1]; // mit integriertem Tepif
    for (int i=l;i<=r;i++) {
      B[0][i] = i;
      B[1][i] = i;
    }
    resolve(A, B, r, root);
  }

  protected class node {
    public int index;
    public node left;
    public node right;
    public int  balance;
    public node(int index) {
      this.index   = index;
      this.left    = null;
      this.right   = null;
      this.balance = 0;
    }
  }

  protected int pbal;           // Balance-nderung des Parents

  protected node rrot(node a) { // Rechtsrotation
    node b  = a.left;
    node c  = b.right;
    b.right = a;
    a.left  = c;
    pbal   += a.balance+1;
    if (b.balance <= 0) {
      a.balance -= b.balance-1;
      b.balance += a.balance+1;
    } else {
      a.balance = 0;
      b.balance = 2;
    }
    return b;
  }

  protected node lrot(node a) { // Linksrotation
    node b  = a.right;
    node c  = b.left;
    b.left  = a;
    a.right = c;
    pbal   -= a.balance-1;
    if (b.balance >= 0) {
      a.balance -= b.balance+1;
      b.balance += a.balance-1;
    } else {
      a.balance =  0;
      b.balance = -2;
    }
    return b;
  }

  protected node balance(node a, int bal) {      // bal darf nur -1, 0 oder +1 sein!
    pbal = 0;
    if (bal != 0) {
      a.balance += bal;                          // Balance aktualisieren
      if (a.balance == -2) {                     // Fall 1.3
        if (a.left.balance == -1) {              // Fall 1.3.1
          pbal++;
          return rrot(a);
        } else {                                 // Fall 1.3.2
          a.left     = lrot(a.left);
          a.balance -= pbal;
          pbal++;
          return rrot(a);
        }
      } else if (a.balance == +2) {              // Fall 2.3
        if (a.right.balance == +1) {             // Fall 2.3.1
          pbal++;
          return lrot(a);
        } else {                                 // Fall 2.3.2
          a.right    = rrot(a.right);
          a.balance += pbal;
          pbal++;
          return lrot(a);
        }
      } else if (a.balance != 0) {               // Hhe hat sich echt gendert!
        pbal++;                                  // Fall 1.1, 1.2, 1.3, 2.1, 2.2, 2.3
        return a;
      }
    }
    return a;                                    // Hhe hat sich nicht gendert!
  }

  protected node insert(ifield A, node current, node element) { // neuen Knoten einfgen
    if (A.lt(element.index, current.index)) {
      if (current.left != null) {
        current.left = insert(A, current.left, element);
        pbal         = -pbal;
      } else {
        current.left = element;
        pbal         = -1;
      }
    } else {
      if (current.right != null) {
        current.right = insert(A, current.right, element);
      } else {
        current.right = element;
        pbal          = +1;
      }
    }
    return balance(current, pbal);
  }

  protected int resolve(ifield A, int[][] B, int index, node current) { // Baum auflsen
    if (current != null) {
      index = resolve(A, B, index, current.right);
      int s = B[0][current.index];
      int t = B[1][index];
      A.exchange(s, index);
      B[0][t] = s;
      B[1][s] = t;
      index--;
      return resolve(A, B, index, current.left);
    } else {
      return index;
    }
  }

/*  protected int checkbal(node current) { // Test, ob wirklich hhenbalanciert
    if (current != null) {
      int hl = checkbal(current.left);
      int hr = checkbal(current.right);
      if (((hr-hl) != current.balance) || (current.balance < -1) || (current.balance > +1)) {
        System.out.println("Fehler: "+(hr-hl)+" != "+current.balance+" ("+current.index+")");
      }
      return Math.max(hl, hr)+1;
    } else {
      return 0;
    }
  }*/
}

