// Peter Weigel

// Bitonic Mergesort
// Variante 6+1

package pefas.sort;

import pefas.field.ifield;

public class btmsort16 extends sort {

  public void sort(ifield A, int l, int r) {
    int[][] B = new int[2][r+1];
    sort(A, B, l, r, true);
  }

  public void sort(ifield A, int[][] B, int l, int r, boolean asc) {
    if (l < r) {
      int q= (l+r)/2;
      sort(A, B, l, q, true);
      sort(A, B, q+1, r, false);
      merge(A, B, l, r, asc);
    }
  }

  protected void merge(ifield A, int[][] B, int l, int r, boolean asc) {
    for (int i=l;i<=r;i++) {
      B[0][i] = i;
      B[1][i] = i;
    }
    int k = asc ?  l :  r;
    int c = asc ? +1 : -1;
    int i= l;
    int j= r;
    while (i < j) {
      int s= B[0][i];
      int t= B[0][j];
      if (A.lt(s, t)) {
      //if ((A.lt(s, t)) || (asc && (A.eq(s, t)))) { // Gekrzt, da Elemente eindeutig
        i++;
      } else {
        s= t;
        j--;
      }
      A.exchange(s, k);
      t= B[1][k];
      B[0][t]= s;
      B[1][s]= t;
      k += c;
    }
  }

}
