// Peter Weigel

// Heapsort
// Variante n

package pefas.sort;

import pefas.field.ifield;

public class heapsortn extends sort {
  protected int k;

  public heapsortn(int k) {
    super();
    this.k = k;
  }

  public void sort(ifield A, int l, int r) {
    buildheap(A, l, r);
    for (int i=r; i>l; i--) {
      A.exchange(l, i);
      heapify(A, l, l, i-1);
    }
  }

  protected void heapify(ifield A, int l, int q, int r) {
    int largest= l+k*(q-l)+1;
    if (largest <= r) {
      int p = largest+k-1;
      for (int i=largest+1;i<=p;i++) {
        if ((i <= r) && (A.gt(i, largest))) {
          largest = i;
        }
      }
      if (A.gt(largest, q)) {
        A.exchange(q, largest);
        heapify(A, l, largest, r);
      }
    }
  }

  protected void buildheap(ifield A, int l, int r) {
    for (int i= (int) ((r-l-1)/k); i>=0; i--) {
      heapify(A, l, l+i, r);
    }
  }

}