// Peter Weigel

// MSsort
// Variante 1

package pefas.sort;

import pefas.field.ifield;

public class mssort1 extends sort {

  public void sort(ifield A, int l, int r) {
    int m = ((r-l+1)/64);
    for (int i=l; i<=r-m+1;i+=m) {
      sort1(A, i, i+m-1);
    }
    sort2(A, l, r, m);
  }

  protected void sort1(ifield A, int l, int r) {
    for (int i=r; i>l; i--) {
      for (int j=l; j<i; j++) {
        if (A.gt(j, j+1)) {
          A.exchange(j, j+1);
        }
      }
    }
  }

  protected void sort2(ifield A, int l, int r, int m) {
    int[][] B = new int[2][r+1];
    for (int i=r-m+1; i>=l+m; i-=m) {
      for (int j=l; j<=i-m; j+=m) {
        merge(A, B, j, j+m-1, j+2*m-1);
      }
    }
  }

  protected void merge(ifield A, int[][] B, int l, int q, int r) {      // Aufteilen eines Teilfeldes in zwei Teilfelder
    for (int i=l;i<=q;i++) {
      B[0][i] = i;
      B[1][i] = i;
    }
    for (int i=r;i>q;i--) {
      B[0][i] = r+q+1-i;
      B[1][i] = r+q+1-i;
    }
    int i= l;
    int j= r;
    for (int k=l; k<r;k++) {
      int s= B[0][i];
      int t= B[0][j];
      if (!A.gt(s, t)) {
        i++;
      } else {
        s= t;
        j--;
      }
      A.exchange(s, k);
      t= B[1][k];
      B[0][t]= s;
      B[1][s]= t;
    }
  }

}
