// Peter Weigel

// Shellsort
// Variante 3

package pefas.sort;

import pefas.field.ifield;

public class shellsort3 extends sort {

  public void sort(ifield A, int l, int r) {
    int q = (int) (Math.log(r-l+1)/Math.log(2));
    int step= (int) Math.pow(2, q) - 1;
    do {
      step = (step-1)/2;
      for (int i=0;i<step;i++) {
        insertsort(A, l+i, r, step);
      }
    } while (step > 1);
  }

  protected void insertsort(ifield A, int l, int r, int step) {
    for (int i=l+step; i<=r; i+=step) {
      int j= i;
      while ((j>l) && (A.gt(j-step, j))) {
        A.exchange(j-step, j);
        j -= step;
      }
    }
  }
}
