// Bezeichnung: Visuelles Punkte/Integer-Feld
// Autor      : Peter Weigel, Andreas Brotzmann
// Fehler werden nicht korrekt geprft!

import java.awt.*;
import java.util.*;
import pefas.field.*;


class ptfield extends Panel implements iintfield { //Point Field
  protected ptele[] items;
  protected int     length;
  protected int update = 0;
  protected boolean breakFlag = false;		//gesetzt, falls Sortierung abgebrochen werden soll
  protected Color pointColor;   // Farbe zum zeichnen
  protected Color sortColor;    // Farbe zum zeichnen (sortierte Position)
  protected Graphics g = null;
  protected Dimension d = null;

  protected int		sd = 0;  // SpeedDown in Millisekunden pro dc Aktionen
  protected int		dc = 100; // delay:=sd/dc;
  protected int		delaycount = 0;

  public ptfield(int n) {                 // Konstruktor
    items  = new ptele[n];              // Maximallnge festlegen, aber
    length = 0;                         // am Anfang ist es trotzdem leer.
  	setForeground(pointColor = Color.blue);
	  setSortColor(Color.red);
	  setBackground(new Color(255,255,200));
    this.d = getSize();
  }

  public int maxLength() {              // maximale Feldlnge ermitteln
    return items.length;                // Das kann uns das Feld am besten sagen.
  }

  public synchronized int length() {    // reale Feldlnge ermitteln
    return length;                      // Die Lnge steht immer hier drin.
  }

  public synchronized boolean lt(int i, int j) {            // Vergleich zweier Elemente
    abort(false);
    delay();
    return (items[i].lessthan(items[j]));
  }

  public synchronized boolean gt(int i, int j) {            // Vergleich zweier Elemente
    return lt(j, i);
  }

  public synchronized boolean eq(int i, int j) {            // Vergleich zweier Elemente
    abort(false);
    delay();
    return (items[i].equal(items[j]));
  }

  public synchronized void exchange(int i, int j) {         // Austausch zweier Elemente
    abort(false);
    if (i != j) {
      delay();
      ptele ele = items[i];
      items[i]  = items[j];
      items[j]  = ele;
      items[i].setIndex(i);items[i].paint();
      items[j].setIndex(j);items[j].paint();
    }
  }

  public void move(int i, int j) {             // Verschieben eines Elementes
    if (i != j) {
      if (i < j) { moveup  (i, j); }           // move right/up
      else       { movedown(i, j); }           // move left/down
    }
  }

  protected void moveup(int i, int j) {       // move fr i < j
    for (int k=i; k<j; k++) {                 // Das ganze geht auch doppelt so schnell (ohne exchange),
      exchange(k, k+1);                       // sieht dann aber unbersichtlicher aus...
    }
  }

  protected void movedown(int i, int j) {     // move fr i >= j
    for (int k=i; k>j; k--) {                 // ... und die Laufzeit ist eh schon schlecht genug,
      exchange(k, k-1);                       // da fllt das garnicht mehr auf :-)
    }
  }

  protected synchronized void append(ptele ele) {        // Feld um ein Element erweitern (am Ende)
    if (length < items.length) {            // Kann Feld noch erweitert werden?
      length++;                             // Lnge um eins erhhen
      items[length-1] = ele;                // und Element reinsetzen.
      ele.setIndex(length-1);
      Update();                             // Lnge hat sich gendert!
    }
  }

  public synchronized void append(int value) { // Feld vergrern und neuen Wert am Ende einfgen
    append(new ptele(value, this));
  }

  public synchronized void delete() {       // Feld um ein Element verkleinern (am Ende)
    items[length-1].setIndex(-1);
    items[length-1] = null;                    // Referenz auf das Element entfernen
    length--;                                  // und Lnge erniedrigen.
    Update();                                  // Lnge hat sich gendert!
  }

  public synchronized void clear() {        // Alle Elemente lschen
    BeginUpdate();
    while (length() > 0) {
      delete();
    }
    System.gc();
    EndUpdate();
  }

  public String toString() {                  // Listeninhalt ausgeben
    return "()";
  }

  public synchronized void value(int i, int value) {       // Wert setzen
    items[i].setIndex(-1);
    items[i] = new ptele(value, this);
    items[i].setIndex(i);
    items[i].refresh();
  }

  public synchronized int value(int i) {                   // Wert ermitteln
    return items[i].value();
  }


  public void abort() {
    breakFlag = true;
  }

  protected void abort(boolean breakFlag) {
    if ((this.breakFlag) || (breakFlag)) {
      this.breakFlag = false;
      throw new RuntimeException(); //Sortierung abbrechen
    }
  }

  public Dimension getPreferredSize(){
  	return new Dimension(512,512);
  }

  public Color getSortColor(){
  	return sortColor;
  	}

  public void setSortColor(Color sortColor){
  	this.sortColor = sortColor;
 	}

  public synchronized void randomfill(int n) {
    BeginUpdate();
  	clear();
  	for (int i=0; i<n;i++) { // Feld korrekt fllen
		  append(i);
    }
	  for (int i=0; i<length();i++) {// und anschlieend Werte durcheinander bringen
		  exchange(i, (int) Math.round(Math.random()*(length()-1)));
    }
    EndUpdate();
	}

  public synchronized void sortedfill_up(int n){
    BeginUpdate();
  	clear();
  	for (int i=0; i<n;i++) {
	  	append(i);
    }
    EndUpdate();
  }

  public synchronized void sortedfill_dn(int n){
    BeginUpdate();
	  clear();
  	for (int i=0; i<n;i++) {
		  append(n-i-1);
		}
    EndUpdate();
	}

  public synchronized void squarefill(int n){
    BeginUpdate(); // n mu geradzahlig sein!
	  clear();
    int p = n/2;
    int q = p-2;
  	for (;q>=0;p +=2,q -=2) {
		  append(p);
		  append(q);
		}
    p--;q +=3;
  	for (;p>q;p -=2,q +=2) {
		  append(p);
		  append(q);
		}
    EndUpdate();
	}

  public synchronized void crossfill(int n){
    BeginUpdate();
  	clear();
  	for (int i=0; i<n;i++) {
	  	append(i);
    }
  	for (int i=1; 2*i<n;i +=2) {
	  	exchange(i, n-i);
    }
    EndUpdate();
  }

  public synchronized boolean sorted() {
    boolean s = true;
  	for (int i=0; i<length;i++) {
      s = (s && (items[i].value()==i));
		}
    return s;
  }

  public synchronized void spotfill(int n) {
    BeginUpdate();
  	clear();
    int[] c = new int[n/16]; // n/16 Flecken...
  	for (int i=0; i<c.length;i++) {
      c[i] = i;
    }
    int l = n/c.length;              // Unsortiert...
  	for (int i=0; i<c.length;i++) {
      int j = (int) Math.round(Math.random()*(c.length-1));
      int s = c[i];
      c[i]  = c[j];
      c[j]  = s;
    }
  	for (int i=0; i<c.length;i++) {  // Und innerlich zufllig
      int k = length;
  	  for (int j=0; j<l;j++) {
		    append(c[i]*l+j);
      }
	    for (int j=k; j<k+l;j++) {
		    exchange(j, k+ (int) Math.round(Math.random()*(l-1)));
      }
    }
    EndUpdate();
	}

  public synchronized void paint(Graphics g) { // Gesamte Visualisierung aktualisieren
    super.paint(g);                            // Zugriff auf point, width, ... und
    this.g = getGraphics();
    this.d = getSize();
    g.clearRect(0, 0, d.width, d.height);
	  for (int i=0; i<length();i++) {
  	  items[i].refresh();
    }
  }

  public synchronized void setDelay(int nanos){	//fr Controlpanel zum setzten der Pause-Zeit
  	if (nanos > 0) {
      dc = (int) Math.ceil(10000000 / nanos); // wollen mind. 10ms warten
  	  sd = nanos*dc / 1000000;
    } else {
      sd = 0;
      dc = 0;
    }
 	}

  protected void delay(long millis) {		//anzahl millisekunden warten
    try { Thread.sleep(millis); }
    catch (InterruptedException e) {};
  }

  protected void delay(){			//wird von exchange usw. aufgerufen
  	if ((sd == 0) || (update != 0)) return;
	  delaycount++;
	  if (delaycount >= dc) {
		  delay(sd);
		  delaycount = 0;
		}
  }

  protected synchronized void BeginUpdate() {
    update++;
  }

  protected synchronized void EndUpdate() {
    update--;
    Update();
  }

  protected synchronized void Update() {
    if ((update == 0) && (g != null)) {
      g.clearRect(0, 0, d.width, d.height);
  	  for (int i=0; i<length();i++) {
	  	  items[i].refresh();
      }
    }
  }

}
